usaco 2003 fall Cow Exhibition 奶牛展览会 题解

Cow Exhibition题解
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 8380   Accepted: 3106

Description

"Fat and docile, big and dumb, they look so stupid, they aren't much 
fun..." 
- Cows with Guns by Dana Lyons 

The cows want to prove to the public that they are both smart and fun. In order to do this, Bessie has organized an exhibition that will be put on by the cows. She has given each of the N (1 <= N <= 100) cows a thorough interview and determined two values for each cow: the smartness Si (-1000 <= Si <= 1000) of the cow and the funness Fi (-1000 <= Fi <= 1000) of the cow. 

Bessie must choose which cows she wants to bring to her exhibition. She believes that the total smartness TS of the group is the sum of the Si's and, likewise, the total funness TF of the group is the sum of the Fi's. Bessie wants to maximize the sum of TS and TF, but she also wants both of these values to be non-negative (since she must also show that the cows are well-rounded; a negative TS or TF would ruin this). Help Bessie maximize the sum of TS and TF without letting either of these values become negative. 

Input

* Line 1: A single integer N, the number of cows 

* Lines 2..N+1: Two space-separated integers Si and Fi, respectively the smartness and funness for each cow. 

Output

* Line 1: One integer: the optimal sum of TS and TF such that both TS and TF are non-negative. If no subset of the cows has non-negative TS and non- negative TF, print 0. 

Sample Input

5
-5 7
8 -6
6 -3
2 1
-8 -5

Sample Output

8

Hint

OUTPUT DETAILS: 

Bessie chooses cows 1, 3, and 4, giving values of TS = -5+6+2 = 3 and TF 
= 7-3+1 = 5, so 3+5 = 8. Note that adding cow 2 would improve the value 
of TS+TF to 10, but the new value of TF would be negative, so it is not 
allowed. 

Source

USACO 2003 Fall

【序言】哎,DP太弱了。于是我翻出了这道以前没有A掉的DP仔细研究。

【初步分析】一瞬间觉得是贪心,后来发现每次有两个值在变化,所以不能贪。那么就DP。这种不能用n^2的方法做,因为对于选第i个牛,并不是完全有之前的第j头牛决定的。然后我就想到了二维DP(有点像搭建双塔)。f[i][j]表示两个值在i和j时的状态是否能达到——结果发现,超内存和时间了。

【仔细研究】我们发现,其实有很多状态都是冗余的。因此我们可以用01背包来做。f[i]表示第一个值在i时第二个值的最大值。当然呢,因为有负数的情况,我们还要把数组下标转成正数。还有,负数时要正着循环(其实也是倒着的,因为绝对值的问题)

【代码】

#include
using namespace std;
const int INF=2100000000;
const int maxn=100000;const int add=100000;
int f[maxn+add+1],a,b,n,i,j,ans;
int main()
{
  scanf("%ld",&n);
  for (j=0;j<=maxn+add;j++) f[j]=-INF;
  f[add]=0;
  for (i=1;i<=n;i++)
  {
    scanf("%ld%ld",&a,&b);
    if (a>0)
    {
      for (j=maxn+add;j>=a;j--)
        if (f[j-a]+b>f[j]&&f[j-a]>-INF) f[j]=f[j-a]+b;
    }
    else 
    {
      for (j=0;j<=maxn+add+a;j++)
        if (f[j-a]+b>f[j]&&f[j-a]>-INF) f[j]=f[j-a]+b;
    }
  }
  for (i=add;i<=maxn+add;i++)
    if (f[i]>=0&&i+f[i]-add>ans) ans=i+f[i]-add;
  printf("%ld",ans);
  return 0;
}

你可能感兴趣的:(usaco题解,poj题解)